
kActor@ UDamSound;   // actor to source quad fire sound from
int UDamTick;        // player tick when quad damage began
int UDamExpireTones; // how many expire tones left to play

void UDamInit()
{
	@UDamSound = ActorFactory.Spawn( -1, Player.Actor().Origin().x, Player.Actor().Origin().y, Player.Actor().Origin().z, 0, Player.Actor().SectorIndex() );
	UDamTick = -3600;
}

int UDamRemaining()
{
	return 30*60 - (Player.Actor().GameTicks() - UDamTick);
}

bool UDamage()
{
	int remaining = UDamRemaining();
	if ( remaining > 0 )
	{
		if ( UDamSound !is null )
		{
			UDamSound.StopSound();
			if ( remaining > 5*60 )
				UDamSound.PlaySound( "UT/sounds/Pickups/Amp_Fire.ksnd" );
			else
				UDamSound.PlaySound( "UT/sounds/Pickups/Amp_Fire_Fading.ksnd" );
		}
		return true;
	}
	return false;
}

void UpdateUDam( kWeapon@ wep )
{
	int remaining = UDamRemaining();
	// keep updating position for amp fire sound length after expiration
	if ( remaining > -1.5f*60 && UDamSound !is null )
		UDamSound.Origin() = EyePos();
	if ( remaining <= 0 )
		return;
	if ( remaining <= 60 * UDamExpireTones )
	{
		wep.PlaySound( "UT/sounds/Pickups/Amp_Stop.ksnd" );
		UDamExpireTones--;
	}
/*	if (    remaining > 5*60                          // before expire sound
		|| (remaining <= 4.5f*60 && remaining > 4*60) // as first tone fades
		|| (remaining <= 3.5f*60 && remaining > 3*60) // as second tone fades
		|| (remaining <= 2.5f*60 && remaining > 2*60) // as third tone fades
		|| (remaining <= 1.5f*60 && remaining >   60) // as fourth tone fades
		||  remaining <= 0.5f*60 )                    // as fifth tone fades
*/			wep.RunFxEvent( "UDamage" );
}

class DamageAmplifier : ScriptObject
{
	DamageAmplifier( kActor@ a ) {}

	// actor was removed, which means it was picked up
	// (or level end, in which case it will be undone by level init)
	~DamageAmplifier()
	{
		UDamTick = Player.Actor().GameTicks();
		UDamExpireTones = 5;
	}

	void OnSpawn() {}
	void OnTick() {}
}
